var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { unref, ref, shallowRef, Fragment, defineComponent, toRef, watch, onMounted, provide, computed, cloneVNode, h, Transition, createCommentVNode, inject, Teleport } from "vue";
import { arrow as arrow$1, computePosition, offset, flip, shift, autoPlacement, hide, autoUpdate } from "@floating-ui/dom";
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
var FUNC_ERROR_TEXT = "Expected a function";
var NAN = 0 / 0;
var symbolTag = "[object Symbol]";
var reTrim = /^\s+|\s+$/g;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
var freeGlobal = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal || freeSelf || Function("return this")();
var objectProto = Object.prototype;
var objectToString = objectProto.toString;
var nativeMax = Math.max, nativeMin = Math.min;
var now = function() {
  return root.Date.now();
};
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, result2 = wait - timeSinceLastCall;
    return maxing ? nativeMin(result2, maxWait - timeSinceLastInvoke) : result2;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}
function throttle(func, wait, options) {
  var leading = true, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  if (isObject(options)) {
    leading = "leading" in options ? !!options.leading : leading;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  return debounce(func, wait, {
    "leading": leading,
    "maxWait": wait,
    "trailing": trailing
  });
}
function isObject(value) {
  var type = typeof value;
  return !!value && (type == "object" || type == "function");
}
function isObjectLike(value) {
  return !!value && typeof value == "object";
}
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
}
function toNumber(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, "");
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var lodash_throttle = throttle;
function dom(ref2) {
  var _a;
  ref2 = unref(ref2);
  if (ref2 == null)
    return null;
  return (_a = ref2 == null ? void 0 : ref2.$el) != null ? _a : ref2;
}
function useFloating(options = {}) {
  const reference = ref(null);
  const floating = ref(null);
  const x = ref(void 0);
  const y = ref(void 0);
  const placement = ref(unref(options.placement || "bottom"));
  const strategy = ref(unref(options.strategy || "absolute"));
  const middlewareData = shallowRef({});
  const update = () => {
    const referenceDom = dom(reference);
    const floatingDom = dom(floating);
    if (!referenceDom || !floatingDom) {
      return;
    }
    computePosition(referenceDom, floatingDom, {
      placement: unref(options.placement),
      strategy: unref(options.strategy),
      middleware: unref(options.middleware)
    }).then((data) => {
      x.value = data.x;
      y.value = data.y;
      placement.value = data.placement;
      strategy.value = data.strategy;
      middlewareData.value = data.middlewareData;
    });
  };
  return { x, y, placement, strategy, middlewareData, update, reference, floating };
}
const arrow = (options) => {
  const { padding } = options;
  return {
    name: "arrow",
    options,
    fn(args) {
      const element = unref(options.element);
      if (element) {
        return arrow$1({ element, padding }).fn(args);
      }
      return {};
    }
  };
};
const tailwindcssOriginSafelist = [
  "origin-bottom",
  "origin-top",
  "origin-right",
  "origin-left",
  "origin-bottom-left",
  "origin-bottom-right",
  "origin-top-left",
  "origin-top-right"
];
const tailwindcssOriginClassResolver = (placement) => {
  switch (placement) {
    case "top":
      return "origin-bottom";
    case "bottom":
      return "origin-top";
    case "left":
      return "origin-right";
    case "right":
      return "origin-left";
    case "top-start":
    case "right-end":
      return "origin-bottom-left";
    case "top-end":
    case "left-end":
      return "origin-bottom-right";
    case "right-start":
    case "bottom-start":
      return "origin-top-left";
    case "left-start":
    case "bottom-end":
      return "origin-top-right";
    default:
      return "";
  }
};
function flattenFragment(nodes) {
  return nodes.reduce((carry, node) => {
    if (node.type === Fragment) {
      return carry.concat(flattenFragment(node.children));
    }
    return carry.concat(node);
  }, []);
}
function filterSlot(nodes) {
  return nodes.filter(isValidElement);
}
function isValidElement(input) {
  if (input == null)
    return false;
  if (typeof input.type === "string")
    return true;
  if (typeof input.type === "object")
    return true;
  if (typeof input.type === "function")
    return true;
  return false;
}
function isVisibleDOMElement(input) {
  input = unref(input);
  return input && (input == null ? void 0 : input.nodeType) !== Node.COMMENT_NODE;
}
const ArrowContext = Symbol();
function useArrowContext(component) {
  let context = inject(ArrowContext, null);
  if (context === null) {
    let err = new Error(`<${component} /> must be in the <Float /> component.`);
    if (Error.captureStackTrace)
      Error.captureStackTrace(err, useArrowContext);
    throw err;
  }
  return context;
}
const FloatProps = {
  as: {
    type: [String, Object],
    default: "div"
  },
  show: {
    type: Boolean,
    default: null
  },
  placement: {
    type: String,
    default: "bottom-start"
  },
  strategy: {
    type: String,
    default: "absolute"
  },
  offset: [Number, Object, Function],
  shift: {
    type: [Boolean, Number, Object],
    default: false
  },
  flip: {
    type: [Boolean, Number, Object],
    default: false
  },
  arrow: {
    type: [Boolean, Number],
    default: false
  },
  autoPlacement: {
    type: [Boolean, Object],
    default: false
  },
  hide: {
    type: [Boolean, Object],
    default: false
  },
  autoUpdate: {
    type: [Boolean, Object],
    default: true
  },
  zIndex: {
    type: [Number, String],
    default: 9999
  },
  enter: String,
  enterFrom: String,
  enterTo: String,
  leave: String,
  leaveFrom: String,
  leaveTo: String,
  originClass: [String, Function],
  tailwindcssOriginClass: {
    type: Boolean,
    default: false
  },
  portal: {
    type: [Boolean, String],
    default: false
  },
  transform: {
    type: Boolean,
    default: true
  },
  middleware: {
    type: [Array, Function],
    default: () => []
  }
};
const Float = defineComponent({
  name: "Float",
  props: FloatProps,
  emits: ["show", "hide", "update"],
  setup(props, { slots, emit }) {
    const isMounted = ref(false);
    const show = ref(props.show !== null ? props.show : false);
    const propPlacement = toRef(props, "placement");
    const propStrategy = toRef(props, "strategy");
    const middleware = shallowRef(void 0);
    const arrowRef = ref(null);
    const arrowX = ref(void 0);
    const arrowY = ref(void 0);
    const { x, y, placement, strategy, reference, floating, middlewareData, update } = useFloating({
      placement: propPlacement,
      strategy: propStrategy,
      middleware
    });
    const referenceEl = ref(dom(reference));
    const floatingEl = ref(dom(floating));
    const updateEl = () => {
      referenceEl.value = dom(reference);
      floatingEl.value = dom(floating);
    };
    const updateFloating = () => {
      if (!isVisibleDOMElement(referenceEl) || !isVisibleDOMElement(floatingEl))
        return;
      update();
      emit("update");
    };
    watch(propPlacement, () => {
      updateEl();
      updateFloating();
    });
    watch(propStrategy, () => {
      updateEl();
      updateFloating();
    });
    watch([
      () => props.offset,
      () => props.flip,
      () => props.shift,
      () => props.autoPlacement,
      () => props.arrow,
      () => props.hide,
      () => props.middleware
    ], () => {
      updateEl();
      const _middleware = [];
      if (typeof props.offset === "number" || typeof props.offset === "object" || typeof props.offset === "function") {
        _middleware.push(offset(props.offset));
      }
      if (props.flip === true || typeof props.flip === "number" || typeof props.flip === "object") {
        _middleware.push(flip(__spreadValues({
          padding: typeof props.flip === "number" ? props.flip : void 0
        }, typeof props.flip === "object" ? props.flip : {})));
      }
      if (props.shift === true || typeof props.shift === "number" || typeof props.shift === "object") {
        _middleware.push(shift(__spreadValues({
          padding: typeof props.shift === "number" ? props.shift : void 0
        }, typeof props.shift === "object" ? props.shift : {})));
      }
      if (props.autoPlacement === true || typeof props.autoPlacement === "object") {
        _middleware.push(autoPlacement(typeof props.autoPlacement === "object" ? props.autoPlacement : void 0));
      }
      if (props.arrow === true || typeof props.arrow === "number") {
        _middleware.push(arrow({
          element: arrowRef,
          padding: props.arrow === true ? 0 : props.arrow
        }));
      }
      _middleware.push(...typeof props.middleware === "function" ? props.middleware({
        referenceEl,
        floatingEl
      }) : props.middleware);
      if (props.hide === true || typeof props.hide === "object") {
        _middleware.push(hide(typeof props.hide === "object" ? props.hide : void 0));
      }
      middleware.value = _middleware;
      updateFloating();
    }, { immediate: true });
    let disposeAutoUpdate;
    const startAutoUpdate = () => {
      if (isVisibleDOMElement(referenceEl) && isVisibleDOMElement(floatingEl) && props.autoUpdate !== false) {
        disposeAutoUpdate = autoUpdate(referenceEl.value, floatingEl.value, lodash_throttle(updateFloating, 16), typeof props.autoUpdate === "object" ? props.autoUpdate : void 0);
      }
    };
    const clearAutoUpdate = () => {
      if (disposeAutoUpdate)
        disposeAutoUpdate();
      disposeAutoUpdate = void 0;
    };
    const handleShow = () => {
      updateEl();
      if (isVisibleDOMElement(referenceEl) && isVisibleDOMElement(floatingEl) && show.value === true) {
        emit("show");
        startAutoUpdate();
      } else if (show.value === false && disposeAutoUpdate) {
        clearAutoUpdate();
        emit("hide");
      }
    };
    watch(show, handleShow, { immediate: true });
    onMounted(() => {
      isMounted.value = true;
      handleShow();
    });
    watch(middlewareData, () => {
      const arrowData = middlewareData.value.arrow;
      arrowX.value = arrowData == null ? void 0 : arrowData.x;
      arrowY.value = arrowData == null ? void 0 : arrowData.y;
    });
    const arrowApi = {
      ref: arrowRef,
      placement,
      x: arrowX,
      y: arrowY
    };
    provide(ArrowContext, arrowApi);
    return () => {
      if (slots.default) {
        const [referenceNode, floatingNode] = filterSlot(flattenFragment(slots.default() || []));
        if (!isValidElement(referenceNode)) {
          return;
        }
        const originClassValue = computed(() => {
          if (typeof props.originClass === "function") {
            return props.originClass(placement.value);
          } else if (typeof props.originClass === "string") {
            return props.originClass;
          } else if (props.tailwindcssOriginClass) {
            return tailwindcssOriginClassResolver(placement.value);
          }
          return "";
        });
        const transitionProps = {
          enterActiveClass: `${props.enter} ${originClassValue.value}`,
          enterFromClass: props.enterFrom,
          enterToClass: props.enterTo,
          leaveActiveClass: `${props.leave} ${originClassValue.value}`,
          leaveFromClass: props.leaveFrom,
          leaveToClass: props.leaveTo,
          onBeforeEnter() {
            updateEl();
            show.value = true;
          },
          onAfterLeave() {
            show.value = false;
          }
        };
        const floatingProps = {
          ref: floating,
          style: props.transform ? {
            position: strategy.value,
            zIndex: props.zIndex,
            top: "0",
            left: "0",
            right: "auto",
            bottom: "auto",
            transform: `translate(${Math.round(x.value || 0)}px,${Math.round(y.value || 0)}px)`
          } : {
            position: strategy.value,
            zIndex: props.zIndex,
            top: `${y.value || 0}px`,
            left: `${x.value || 0}px`
          }
        };
        const renderPortal = (node) => {
          if (isMounted.value && (props.portal === true || typeof props.portal === "string")) {
            return h(Teleport, {
              to: props.portal === true ? "body" : props.portal
            }, [node]);
          }
          return node;
        };
        const renderFloating = (node) => {
          if (props.as === "template") {
            return node;
          }
          return h(props.as, floatingProps, node);
        };
        return [
          cloneVNode(referenceNode, { ref: reference }),
          renderPortal(renderFloating(h(Transition, transitionProps, () => (typeof props.show === "boolean" ? props.show : true) ? cloneVNode(floatingNode, props.as === "template" ? floatingProps : null) : createCommentVNode())))
        ];
      }
    };
  }
});
const FloatArrow = defineComponent({
  name: "FloatArrow",
  props: {
    as: {
      type: [String, Object],
      default: "div"
    },
    offset: {
      type: Number,
      default: 4
    }
  },
  setup(props, { slots, attrs }) {
    const { ref: ref2, placement, x, y } = useArrowContext("FloatArrow");
    return () => {
      var _a;
      const staticSide = {
        top: "bottom",
        right: "left",
        bottom: "top",
        left: "right"
      }[placement.value.split("-")[0]];
      const style = {
        left: typeof x.value === "number" ? `${x.value}px` : "",
        top: typeof y.value === "number" ? `${y.value}px` : "",
        right: "",
        bottom: "",
        [staticSide]: `${props.offset * -1}px`
      };
      if (props.as === "template") {
        const slot = { placement: placement.value };
        const children = (_a = slots.default) == null ? void 0 : _a.call(slots, slot);
        const [node] = Array.isArray(children) ? children : [children];
        if (!node || !isValidElement(node)) {
          throw new Error("When the prop `as` of <FloatArrow /> is 'template', there must be contains 1 child element.");
        }
        return cloneVNode(node, { ref: ref2, style });
      }
      return h(props.as, Object.assign({}, attrs, { ref: ref2, style }));
    };
  }
});
const components = [
  "Float",
  "FloatArrow"
];
function HeadlessUiFloatResolver(options = {}) {
  const { prefix = "" } = options;
  return {
    type: "component",
    resolve: (name) => {
      if (name.startsWith(prefix)) {
        const componentName = name.substring(prefix.length);
        if (components.includes(componentName)) {
          return {
            importName: componentName,
            path: "headlessui-float-vue"
          };
        }
      }
    }
  };
}
export { Float, FloatArrow, FloatProps, HeadlessUiFloatResolver, arrow, tailwindcssOriginClassResolver, tailwindcssOriginSafelist, useFloating };
